/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ECTF                                                     */
/* Tabela : EMPRCNTRFIL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ECTF
BEFORE INSERT OR UPDATE OR DELETE
ON EMPRCNTRFIL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUECTF := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINSCESTA,0) <> NVL(:NEW.CDINSCESTA,0)) OR
         (NVL(:OLD.CDINSCMUNI,0) <> NVL(:NEW.CDINSCMUNI,0)) OR
         (NVL(:OLD.CDEMPRESA,0)  <> NVL(:NEW.CDEMPRESA,0))  OR
         (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0))   OR
         (NVL(:OLD.CDSERIE,0)    <> NVL(:NEW.CDSERIE,0))    THEN
         :NEW.DTULTATUECTF := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EMPRCNTRFIL', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDEMPRESA='||:OLD.CDEMPRESA||';CDINSCESTA='||:OLD.CDINSCESTA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EMPRCNTRFIL MODIFY DTULTATUECTF DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ECTF','5.60.XXX'); END;
/

