  X/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MENS                                                     */
/* Tabela : MENSAGEM                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MENS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MENS
GO

CREATE TRIGGER DTULTATU_MENS
ON MENSAGEM
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MENSAGEM', null, 'CDMENSAGEM=' + CDMENSAGEM + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MENSAGEM
      SET DTULTATUMENS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(MENSAGEM.CDMENSAGEM,0) = ISNULL(INSERTED.CDMENSAGEM,0)) AND
            (ISNULL(MENSAGEM.DSMENSAGEM,0) = ISNULL(INSERTED.DSMENSAGEM,0)) AND
            (ISNULL(MENSAGEM.IDSITUACAOMENS,0) = ISNULL(INSERTED.IDSITUACAOMENS,0));
   END;
END;
GO