/*
 Tecnisa - Tecnologia em Informtica

 Nome: ULTIMA_ANALISE_LOTE

  Descrio:
  Funo para detectar a ultima analise do lote de um produto e, posteriormente, preencher as tabelas temporrias conforme a analise encontrada.

*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ULTIMA_ANALISE_LOTE'
             AND TYPE = 'TF'
             AND U.UID = O.UID
             AND U.NAME = USER)
DROP FUNCTION ULTIMA_ANALISE_LOTE
GO

CREATE FUNCTION ULTIMA_ANALISE_LOTE
(
@P_CDFILIAL    VARCHAR(4),
@P_CDPRODUTO   VARCHAR(10),
@P_NRLOTEESTQ  VARCHAR(20),
@P_NRSUBLOTE   VARCHAR(4)
)
returns @ULTIMA_ANALISE table
(
NRAUDITORIA VARCHAR(10),
DTVALANA DATE,
IDTIPOANA VARCHAR(1),
IDSTATUSAUDI VARCHAR(1)
)
AS
BEGIN
   DECLARE @V_NRAUDITORIA VARCHAR(10);
   DECLARE @V_DTVALANA DATE;
   DECLARE @V_IDTIPOANA VARCHAR(1);
   DECLARE @V_IDSTATUSAUDI VARCHAR(1);

   DECLARE @C_AUDITORIA_NRAUDITORIA VARCHAR(10);
   DECLARE @C_AUDITORIA_DTVALANA DATE;
   DECLARE @C_AUDITORIA_IDTIPOANA VARCHAR(1);
   DECLARE @C_AUDITORIA_IDSTATUSAUDI VARCHAR(1);

   DECLARE C_AUDITORIA CURSOR FOR
      SELECT MAX(A.NRAUDITORIA) A.NRAUDITORIA, A.DTVALANA, A.IDTIPOANA, A.IDSTATUSAUDI
           FROM AUDITORIA A, PARAMETROQPR P
          WHERE ((A.CDFILIAL = @P_CDFILIAL) OR (A.CDFILIAL = P.CDFILICONTANAUNI))
            AND P.CDFILIAL = A.CDFILIAL(+)
            AND A.CDPRODUTO = @P_CDPRODUTO
            AND A.NRLOTEESTQ = @P_NRLOTEESTQ
            AND A.NRSUBLOTE = @P_NRSUBLOTE
            AND A.IDSTATUSAUDI <> '3'
          GROUP BY A.DTVALANA, A.IDTIPOANA, A.IDSTATUSAUDI
          ORDER BY MAX(A.NRAUDITORIA);
   OPEN C_AUDITORIA;
   FETCH C_AUDITORIA INTO @C_AUDITORIA_NRAUDITORIA, @C_AUDITORIA_DTVALANA, @C_AUDITORIA_IDTIPOANA, @C_AUDITORIA_IDSTATUSAUDI;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_NRAUDITORIA  = @C_AUDITORIA_NRAUDITORIA;
      SET @V_DTVALANA     = @C_AUDITORIA_DTVALANA;
      SET @V_IDTIPOANA    = @C_AUDITORIA_IDTIPOANA;
      SET @V_IDSTATUSAUDI = @C_AUDITORIA_IDSTATUSAUDI;

      IF @V_NRAUDITORIA IS NOT NULL BEGIN
         IF @V_DTVALANA        IS NOT NULL OR
            @V_IDTIPOANA       IS NOT NULL OR
            @V_IDSTATUSAUDI    IS NOT NULL BEGIN

            INSERT INTO @ULTIMA_ANALISE
            (NRAUDITORIA,          DTVALANA,            IDTIPOANA,        IDSTATUSAUDI
             )
             VALUES
            (@V_NRAUDITORIA,       @V_DTVALANA,         @V_IDTIPOANA,     @V_IDSTATUSAUDI);
         END;
      END;
      FETCH C_AUDITORIA INTO @C_AUDITORIA_NRAUDITORIA, @C_AUDITORIA_DTVALANA, @C_AUDITORIA_IDTIPOANA, @C_AUDITORIA_IDSTATUSAUDI;
   END;
   CLOSE C_AUDITORIA;
   DEALLOCATE C_AUDITORIA;
   RETURN;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ULTIMA_ANALISE_LOTE','6.19.xxx';
GO